%returns structural IRs (phi) and the estimated
%covariance matrix of the response coefficients' estimators (varmat)

function [phi,varmat]=varmat1(bm, nlags, nvar, h, sigmam, ct,G0,lm,km,sigs);

ia=zeros(nvar,nvar);
ja=zeros(nvar,nvar*nlags);
jb=zeros(nvar,nvar*nlags);
for zz=1:nvar
    ia(zz,:)=1:nvar;
    ja(zz,:)=1:nvar*nlags;
    jb(zz,:)=zz*ones(1,nvar*nlags);
end

ib=ia';

[phi1]=macoef(bm(2:end,:), nlags, nvar, h);

A=bm(2:nvar+1,:)';
for i=1:nlags-1
    A=[A bm(i*nvar+2:(i+1)*nvar+1,:)'];
end

for i=1:nlags-1
    r=zeros(nvar,nvar*nlags);
    r(1:nvar,(i-1)*nvar+1:i*nvar)=eye(nvar);
    A=[A;r];
end

J=zeros(nvar,nvar*nlags);
J(1:nvar,1:nvar)=eye(nvar);

v=zeros(nvar^2*(h+1),nvar^2*nlags);

for i=1:h
    H=zeros(nvar^2,nvar^2*nlags);
    for m=0:i-1
        H=H+kron2(ia,ja,ib,jb,(J*(A')^(i-1-m)),(phi1(m*nvar+1:(m+1)*nvar,:)));
    end
    v(i*nvar^2+1:(i+1)*nvar^2,:)=H;
end

smat=kron1(G0(2:end,2:end),sigmam);

q = chol(sigmam)';

%structural IRs
phi = phi1*q;

H=lm'*inv( lm*(eye(nvar^2)+km)*(kron1(q,eye(nvar)))*lm');

s1=size(H,2);

CV1=zeros(nvar^2*(h+1),nvar^2*nlags);
CbarV1=zeros(nvar^2*(h+1),0.5*nvar*(nvar+1));

kp1=kron1(q',eye(nvar));
for i=0:h

    C=kp1*v(i*nvar^2+1:(i+1)*nvar^2,:);

    Cbar=reshape(phi1(i*nvar+1:(i+1)*nvar,:)*reshape(H, [nvar nvar*s1]), [nvar*nvar s1]);
    for j=1:nvar
        CV1((h+1)*nvar*(j-1)+i*nvar+1:(h+1)*nvar*(j-1)+i*nvar+nvar,:)=C((j-1)*nvar+1:j*nvar,:);
        CbarV1((h+1)*nvar*(j-1)+i*nvar+1:(h+1)*nvar*(j-1)+i*nvar+nvar,:)=Cbar((j-1)*nvar+1:j*nvar,:);
    end
end

varmat=(CV1*smat*CV1'+CbarV1*sigs*CbarV1')/(ct-nlags);