function [sch,sch_mod]=asym_bands(h,nvar,ct,nlags,sl,bm,sigmam,G0m)

lm = elimination(nvar);             %elimination matrix
km = commutation(nvar,nvar);        %commutation matrix
dm = duplication(nvar);             %duplication matrix
dpm = inv(dm'*dm)*dm';              %the Moore-Penrose inverse of the duplication matrix

sigs=2*dpm*kron1(sigmam,sigmam)*dpm'; 

[phi,vmat]=varmat1(bm, nlags, nvar, h, sigmam, ct,G0m,lm,km,sigs);

   chi1=zeros(h+1,1);
       for j=1:(h+1)
        chi1(j)=sqrt(chi2inv((1-sl),j)/j);	   %critical values for Scheffe's band
       end
   chi2=zeros(h,1);
       for j=1:h
        chi2(j)=sqrt(chi2inv((1-sl),j)/j);	   %critical values for Scheffe's band
       end

row=1;
i=1;

uschirf = zeros(h+1, nvar^2);       %upper bound of the Scheffe band
lschirf = zeros(h+1, nvar^2);       %lower bound of the Scheffe band
uschabsirf = zeros(h+1, nvar^2);    %upper bound of the modified Scheffe band
lschabsirf = zeros(h+1, nvar^2);    %lower bound of the modified Scheffe band

sch=zeros(2*nvar^2,h+1);            %the Scheffe bands
sch_mod=zeros(2*nvar^2,h+1);        %modified Scheffe bands

while row<=nvar
    col=1;
while col<=nvar
   
    %selector matrix
    rr=zeros(nvar,1);
    cc=zeros(nvar,1);    
    rr(row)=1;
    cc(col)=1;

    ss=kron(eye(h+1),rr)'; 
    ss=kron(cc',ss); 

    psi = ss*(phi(:));       % select irf
    omega = ss*vmat*ss';     % corresponding covariance matrix
         
    if psi(1,1)==0
    omega2=omega(2:size(omega,1),2:size(omega,2));
    chi=chi2;
    else
    omega2=omega;
    chi=chi1;
    end
    
   [a err] = cholcov(omega2, 0); 
   
   if (err ~= 0)        % the covariance matrix is not positive definite!
    omega2=validateCovMatrix(omega2);
   end
   
    a = chol(omega2); 
    
    %The Scheffe and modified Scheffe bands 
    if psi(1,1)==0
    uschirf(2:end,i) = psi(2:end,1)+ a'*chi;
    lschirf(2:end,i) = psi(2:end,1)- a'*chi;
    uschabsirf(2:end,i) = psi(2:end,1)+ abs(a)'*chi;
    lschabsirf(2:end,i) = psi(2:end,1)- abs(a)'*chi;
    else
    uschirf(:,i) = psi(:,1)+ a'*chi;
    lschirf(:,i) = psi(:,1)- a'*chi;
    uschabsirf(:,i) = psi(:,1)+ abs(a)'*chi;
    lschabsirf(:,i) = psi(:,1)- abs(a)'*chi;
    end
       
    i = i+1;
    col = col+1;
    end
    row = row+1;
end


k=0;
for d=1:nvar
for dd=1:nvar
k=k+1;
sch(2*k-1,:)=lschirf(:,(dd-1)*nvar+d)';
sch(2*k,:)=uschirf(:,(dd-1)*nvar+d)';
sch_mod(2*k-1,:)=lschabsirf(:,(dd-1)*nvar+d)';
sch_mod(2*k,:)=uschabsirf(:,(dd-1)*nvar+d)';
end
end

