function [bp1,irfb,sterr,varmat]=bpaths1(mx,nlags,nvar,ct,h,n)

lm = elimination(nvar);      %elimination matrix
km = commutation(nvar,nvar); %commutation matrix
dm = duplication(nvar);      %duplication matrix
dpm = inv(dm'*dm)*dm';       %the Moore-Penrose inverse of the duplication matrix

ia=[1:(h+1)];
ib=ones(1,h+1);
ja=zeros(nvar,h+1);
jb=zeros(nvar,h+1);
for zz=1:nvar
    ja(zz,:)=ia;
    jb(zz,:)=zz*ib;
end

bp1=zeros(n*nvar^2,h+1);      %bootstrap replicates of response functions
sterr=zeros(n*nvar^2,h+1);    %standardized prediction errors

y=zeros(nvar,ct);

mx1=mx;

for i=1:nvar
    mx1(1:ct,i)=mx(1:ct,i)-mean(mx(1:ct,i));
end

%estimate
bf=forb(mx, mx1, nlags, nvar, ct);

%calculate residuals
[T,T1]=size(mx);
yf=mx((nlags+1):T,1:T1);
xf=ones(T-nlags,1);

for i=1:nlags
    xf=[xf mx((nlags-i+1):(T-i),1:T1)];
end

uf=yf-xf*bf;
sigmaf=uf'*uf/(length(uf));

G0f=inv(xf'*xf)*(length(uf));

uf=uf*((ct-nlags)/(ct-nlags*nvar-1-nlags))^0.5; %scale residuals

sigs=2*dpm*kron1(sigmaf,sigmaf)*dpm';

%responses based on bias-corrected estimators and estimated variance matrix 
%of response coefficients estimators
[rb,varmat]=varmat1(bf,nlags,nvar,h,sigmaf,ct,G0f,lm,km,sigs);  
                                                                
irfb=zeros(nvar^2,h+1);               

for i=1:h+1
    for j=1:nvar
        irfb(nvar*(j-1)+1:nvar*j,i)=rb(nvar*i-nvar+1:nvar*i,j);
    end
end

d=randint(ct-nlags,n,[1,ct-nlags]);

%bootstrap replications
for l=1:n

    ee2=uf(d(:,l),:);

    %generate data
    y(:,1:nlags)=mx(1:nlags,:)';

    for i=nlags:ct-1
        xx=1;
        j=1;
        while(j<nlags+1)
            xx=[xx y(:,i-j+1)'];
            j=j+1;
        end
        y(:,i+1)=(xx*bf)'+ee2(i-nlags+1,:)';
    end

    yt=y';

    for i=1:nvar
        ym1(1:ct,i)=yt(1:ct,i)-mean(yt(1:ct,i));
    end

    nlags1=nlags;

    bf1=forb(yt, ym1, nlags1, nvar, ct);

    %calculate residuals
    [T,T1]=size(ym1);
    yf1=yt((nlags1+1):T,1:T1);
    xf1=ones(T-nlags1,1);

    for i=1:nlags1
        xf1=[xf1 yt((nlags1-i+1):(T-i),1:T1)];
    end

    uf1=yf1-xf1*bf1;
    sigmaf1=uf1'*uf1/(length(uf1));

    G0f1=inv(xf1'*xf1)*(length(uf1));

    sigs1=2*dpm*kron1(sigmaf1,sigmaf1)*dpm';

    [rb1,varmatb]=varmat1(bf1,nlags1,nvar,h,sigmaf1,ct,G0f1,lm,km,sigs1);

    irfb1=zeros(nvar^2,h+1);
    for i=1:h+1
        for j=1:nvar
            irfb1(nvar*(j-1)+1:nvar*j,i)=rb1(nvar*i-nvar+1:nvar*i,j);
        end
    end

    for i=0:nvar^2-1
        bp1(i*n+l,:)=irfb1(i+1,:);
    end

    b=0;
    for a=1:nvar
        varmatb1=varmatb(a*nvar*(h+1)-nvar*(h+1)+1:a*nvar*(h+1),a*nvar*(h+1)-nvar*(h+1)+1:a*nvar*(h+1));
        for i=0:nvar-1
            b=b+1;
            e=zeros(1,nvar);
            e(i+1)=1;
            kpp=kron2(ia,ja,ib,jb,eye(h+1),e);
            v=kpp*varmatb1*(kpp');
            for j=1:h+1
                if irfb1(nvar*(a-1)+1+i,j)-irfb(nvar*(a-1)+1+i,j)==0
                    sterr((b-1)*n+l,j)=0;
                else
                    sterr((b-1)*n+l,j)=(irfb1(nvar*(a-1)+1+i,j)-irfb(nvar*(a-1)+1+i,j))/sqrt(v(j,j));
                end
            end
        end
    end
end